#include "uart.h"
#include "memory/memory.h"
#include <stdio.h>

#define UART_ADDRESS 0x3000000
#define UART_REGISTER_SIZE 4
#define UART_REGISTER_COUNT 1
#define UART_REG_TXFIFO 0x0

void uart_handle_mmio_write(uint32_t address, uint8_t value);
uint32_t uart_handle_mmio_read(uint32_t address);

void uart_init()
{
    mem_register_mmio(UART_ADDRESS, UART_REGISTER_SIZE, UART_REGISTER_COUNT, uart_handle_mmio_write, uart_handle_mmio_read);
}

void uart_handle_mmio_write(uint32_t address, uint8_t value)
{
    printf("%c", value);
}

uint32_t uart_handle_mmio_read(uint32_t address)
{
    return 0;
}
